﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Drawing.Imaging;
using System.Runtime.InteropServices;

namespace CSharp_WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        [DllImport("pdfparsersdk2.dll")]
        private static extern int VeryPDF_PDFParserSDK(string lpPDFFile, string lpOutFile, string lpOptions);

        [DllImport("pdfparsersdk2.dll")]
        private static extern int VeryPDF_PDFParserSDKFromMemory(ref byte lpPDFData, int nDataLen, string lpOutFile, string lpOptions);

        [DllImport("pdfparsersdk2.dll")]
        private static extern int VeryPDF_PDFParserSDK_GetHandle(string lpPDFFile, string lpOptions);

        [DllImport("pdfparsersdk2.dll")]
        private static extern int VeryPDF_PDFParserSDK_GetCount(int hPDFParserData);

        [DllImport("pdfparsersdk2.dll")]
        private static extern int VeryPDF_PDFParserSDK_GetImageLength(int hPDFParserData, int nIndex);

        [DllImport("pdfparsersdk2.dll")]
        private static extern int VeryPDF_PDFParserSDK_GetImageData(int hPDFParserData, int nIndex, [MarshalAs(UnmanagedType.LPArray)] byte[] lpData, int nBufLen);

        [DllImport("pdfparsersdk2.dll")]
        private static extern int VeryPDF_PDFParserSDK_GetTextInfoLength(int hPDFParserData, int nIndex);

        [DllImport("pdfparsersdk2.dll")]
        private static extern int VeryPDF_PDFParserSDK_GetTextInfoData(int hPDFParserData, int nIndex, [MarshalAs(UnmanagedType.LPArray)] byte[] lpData, int nBufLen);

        [DllImport("pdfparsersdk2.dll")]
        private static extern int VeryPDF_PDFParserSDK_Free(int hPDFParserData);

        [DllImport("pdfparsersdk2.dll")]
        private static extern int VeryPDF_PDFParserSDK_GetPageCount(string lpPDFFile);

        [DllImport("pdfparsersdk2.dll")]
        private static extern int VeryPDF_PDFParserSDK_GetAllPagesCount(int hPDFParserData);

        private void DiskFile_Click(object sender, EventArgs e)
        {
            string appPath = Path.GetDirectoryName(Application.ExecutablePath);

            int nRet;
            string strOptions;
            string strInPDFFile;
            string strOutFile;
            string strLogMsg;
            strInPDFFile = (appPath + "\\example1.pdf");
            strOutFile = (appPath + "\\out.png");
            strOptions = "-$ XXXXXXXXXXXXXXXXXXXX -html";
            nRet = VeryPDF_PDFParserSDK(strInPDFFile, strOutFile, strOptions);
            strLogMsg = (strInPDFFile + ("\r\n"
                        + (strOutFile + ("\r\n"
                        + (strOptions + ("\r\n" + ("nRet = " + (nRet.ToString()))))))));
            MessageBox.Show(strLogMsg);
        }

        private void Memory_Click(object sender, EventArgs e)
        {
            int nRet;
            string strOptions;
            string strInPDFFile;
            string strOutFile;
            int nPDFSDKLib;
            int nCount;
            int nItem;
            byte[] vecImgData = null;
            byte[] vecTxtData = null;
            int nImageDataLen;
            int nTextInfoLen;
            string strLogMsg;

            string appPath = Path.GetDirectoryName(Application.ExecutablePath);

            strInPDFFile = (appPath + "\\example1.pdf");
            strOptions = "-$ XXXXXXXXXXXXXXXXXXXX";
            nPDFSDKLib = VeryPDF_PDFParserSDK_GetHandle(strInPDFFile, strOptions);
            nCount = VeryPDF_PDFParserSDK_GetCount(nPDFSDKLib);
            for (nItem = 0; (nItem <= (nCount - 1)); nItem++)
            {
                nImageDataLen = VeryPDF_PDFParserSDK_GetImageLength(nPDFSDKLib, nItem);
                nTextInfoLen = VeryPDF_PDFParserSDK_GetTextInfoLength(nPDFSDKLib, nItem);
                vecImgData = new byte[nImageDataLen];
                vecTxtData = new byte[nTextInfoLen];
                VeryPDF_PDFParserSDK_GetImageData(nPDFSDKLib, nItem, vecImgData, nImageDataLen);
                VeryPDF_PDFParserSDK_GetTextInfoData(nPDFSDKLib, nItem, vecTxtData, nTextInfoLen);
                strLogMsg = System.Text.Encoding.ASCII.GetString(vecTxtData);
                MessageBox.Show(strLogMsg.Substring(0, 300));
            }
            VeryPDF_PDFParserSDK_Free(nPDFSDKLib);
            nPDFSDKLib = 0;
        }

        private void PageByPage_Click(object sender, EventArgs e)
        {
            int nRet;
            string strOptions;
            string strInPDFFile;
            string strOutFile;
            int nPDFSDKLib;
            int nCount;
            int nItem;
            byte[] vecImgData = null;
            byte[] vecTxtData = null;
            int nImageDataLen;
            int nTextInfoLen;
            string strLogMsg;
            int nPageCount;
            int page;

            string appPath = Path.GetDirectoryName(Application.ExecutablePath);
            strInPDFFile = (appPath + "\\example2.pdf");
            nPageCount = VeryPDF_PDFParserSDK_GetPageCount(strInPDFFile);
            for (page = 1; (page <= nPageCount); page++)
            {
                strOptions = ("-$ XXXXXXXXXXXXXXXXXXXX -f "
                            + ((page.ToString()) + (" -l " + (page.ToString()))));
                nPDFSDKLib = VeryPDF_PDFParserSDK_GetHandle(strInPDFFile, strOptions);
                nCount = VeryPDF_PDFParserSDK_GetCount(nPDFSDKLib);
                for (nItem = 0; (nItem <= (nCount - 1)); nItem++)
                {
                    nImageDataLen = VeryPDF_PDFParserSDK_GetImageLength(nPDFSDKLib, nItem);
                    nTextInfoLen = VeryPDF_PDFParserSDK_GetTextInfoLength(nPDFSDKLib, nItem);
                    vecImgData = new byte[nImageDataLen];
                    vecTxtData = new byte[nTextInfoLen];
                    VeryPDF_PDFParserSDK_GetImageData(nPDFSDKLib, nItem, vecImgData, nImageDataLen);
                    VeryPDF_PDFParserSDK_GetTextInfoData(nPDFSDKLib, nItem, vecTxtData, nTextInfoLen);
                    strLogMsg = System.Text.Encoding.ASCII.GetString(vecTxtData);
                    if ((nTextInfoLen == 0))
                    {
                        strLogMsg = "This page hasn\'t text contents.";
                    }
                    if ((strLogMsg.Length > 300))
                    {
                        strLogMsg = strLogMsg.Substring(0, 300);
                    }
                    MessageBox.Show(strLogMsg, ("Text contents of Page " + (page.ToString())));
                }
                VeryPDF_PDFParserSDK_Free(nPDFSDKLib);
                nPDFSDKLib = 0;
            }
        }
    }
}
