﻿Imports System
Imports System.IO
Imports System.Text
Imports System.Drawing
Imports System.Drawing.Imaging

Public Class Form1

    Private Declare Function VeryPDF_PDFParserSDK Lib "pdfparsersdk2.dll" (ByVal lpPDFFile As String, ByVal lpOutFile As String, ByVal lpOptions As String) As Integer
    Private Declare Function VeryPDF_PDFParserSDKFromMemory Lib "pdfparsersdk2.dll" (ByRef lpPDFData As Byte, ByVal nDataLen As Integer, ByVal lpOutFile As String, ByVal lpOptions As String) As Integer
    Private Declare Function VeryPDF_PDFParserSDK_GetHandle Lib "pdfparsersdk2.dll" (ByVal lpPDFFile As String, ByVal lpOptions As String) As Integer
    Private Declare Function VeryPDF_PDFParserSDK_GetCount Lib "pdfparsersdk2.dll" (ByVal hPDFParserData As Integer) As Integer
    Private Declare Function VeryPDF_PDFParserSDK_GetImageLength Lib "pdfparsersdk2.dll" (ByVal hPDFParserData As Integer, ByVal nIndex As Integer) As Integer
    Private Declare Function VeryPDF_PDFParserSDK_GetImageData Lib "pdfparsersdk2.dll" (ByVal hPDFParserData As Integer, ByVal nIndex As Integer, ByRef lpData As Byte, ByVal nBufLen As Integer) As Integer
    Private Declare Function VeryPDF_PDFParserSDK_GetTextInfoLength Lib "pdfparsersdk2.dll" (ByVal hPDFParserData As Integer, ByVal nIndex As Integer) As Integer
    Private Declare Function VeryPDF_PDFParserSDK_GetTextInfoData Lib "pdfparsersdk2.dll" (ByVal hPDFParserData As Integer, ByVal nIndex As Integer, ByRef lpData As Byte, ByVal nBufLen As Integer) As Integer
    Private Declare Function VeryPDF_PDFParserSDK_Free Lib "pdfparsersdk2.dll" (ByVal hPDFParserData As Integer) As Integer
    Private Declare Function VeryPDF_PDFParserSDK_GetPageCount Lib "pdfparsersdk2.dll" (ByVal lpPDFFile As String) As Integer
    Private Declare Function VeryPDF_PDFParserSDK_GetAllPagesCount Lib "pdfparsersdk2.dll" (ByVal hPDFParserData As Integer) As Integer
		
    Public Function Byte2Image(ByVal ByteArr() As Byte) As Image
        Dim NewImage As Image = Nothing
        Dim ImageStream As MemoryStream
        Try
            If ByteArr.GetUpperBound(0) > 0 Then
                ImageStream = New MemoryStream(ByteArr)
                NewImage = Image.FromStream(ImageStream)
            Else
                NewImage = Nothing
            End If
        Catch ex As Exception
            NewImage = Nothing
        End Try
        Byte2Image = NewImage
    End Function

    Public Function Image2Byte(ByRef NewImage As Image) As Byte()
        Dim ImageStream As MemoryStream
        Dim ByteArr() As Byte = Nothing
        Try
            ReDim ByteArr(0)
            If NewImage IsNot Nothing Then
                ImageStream = New MemoryStream
                NewImage.Save(ImageStream, ImageFormat.Png)
                ReDim ByteArr(CInt(ImageStream.Length - 1))
                ImageStream.Position = 0
                ImageStream.Read(ByteArr, 0, CInt(ImageStream.Length))
            End If
        Catch ex As Exception
        End Try
        Image2Byte = ByteArr
    End Function

    Private Sub DiskFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DiskFile.Click
        Dim nRet As Integer
        Dim strOptions As String
        Dim strInPDFFile As String
        Dim strOutFile As String
        Dim strLogMsg As String

        strInPDFFile = Application.StartupPath() & "\example1.pdf"
        strOutFile = Application.StartupPath() & "\out.png"
        strOptions = "-$ XXXXXXXXXXXXXXXXXXXX"
        nRet = VeryPDF_PDFParserSDK(strInPDFFile, strOutFile, strOptions)
        strLogMsg = strInPDFFile & vbCrLf & strOutFile & vbCrLf & strOptions & vbCrLf & "nRet = " & Str(nRet)
        MsgBox(strLogMsg)
    End Sub

    Private Sub Memory_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Memory.Click
        Dim nRet As Integer
        Dim strOptions As String
        Dim strInPDFFile As String
        Dim strOutFile As String
        Dim nPDFSDKLib As Integer
        Dim nCount As Integer
        Dim nItem As Integer
        Dim vecImgData() As Byte = Nothing
        Dim vecTxtData() As Byte = Nothing
        Dim nImageDataLen As Integer
        Dim nTextInfoLen As Integer
        Dim strLogMsg As String

        strInPDFFile = Application.StartupPath() & "\example1.pdf"
        strOptions = "-$ XXXXXXXXXXXXXXXXXXXX"
        nPDFSDKLib = VeryPDF_PDFParserSDK_GetHandle(strInPDFFile, strOptions)
        nCount = VeryPDF_PDFParserSDK_GetCount(nPDFSDKLib)
        For nItem = 0 To nCount - 1
            nImageDataLen = VeryPDF_PDFParserSDK_GetImageLength(nPDFSDKLib, nItem)
            nTextInfoLen = VeryPDF_PDFParserSDK_GetTextInfoLength(nPDFSDKLib, nItem)
            ReDim vecImgData(nImageDataLen)
            ReDim vecTxtData(nTextInfoLen)
            VeryPDF_PDFParserSDK_GetImageData(nPDFSDKLib, nItem, vecImgData(0), nImageDataLen)
            VeryPDF_PDFParserSDK_GetTextInfoData(nPDFSDKLib, nItem, vecTxtData(0), nTextInfoLen)
            strLogMsg = System.Text.Encoding.ASCII.GetString(vecTxtData)
            MsgBox(strLogMsg.Substring(0, 300))
        Next nItem
        VeryPDF_PDFParserSDK_Free(nPDFSDKLib)
        nPDFSDKLib = Nothing
    End Sub

    Private Sub PageByPage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PageByPage.Click
        Dim nRet As Integer
        Dim strOptions As String
        Dim strInPDFFile As String
        Dim strOutFile As String
        Dim nPDFSDKLib As Integer
        Dim nCount As Integer
        Dim nItem As Integer
        Dim vecImgData() As Byte = Nothing
        Dim vecTxtData() As Byte = Nothing
        Dim nImageDataLen As Integer
        Dim nTextInfoLen As Integer
        Dim strLogMsg As String
        Dim nPageCount As Integer
        Dim page As Integer

        strInPDFFile = Application.StartupPath() & "\example2.pdf"

        nPageCount = VeryPDF_PDFParserSDK_GetPageCount(strInPDFFile)
        For page = 1 To nPageCount
            strOptions = "-$ XXXXXXXXXXXXXXXXXXXX -f " & Str(page) & " -l " & Str(page)
            nPDFSDKLib = VeryPDF_PDFParserSDK_GetHandle(strInPDFFile, strOptions)
            nCount = VeryPDF_PDFParserSDK_GetCount(nPDFSDKLib)
            For nItem = 0 To nCount - 1
                nImageDataLen = VeryPDF_PDFParserSDK_GetImageLength(nPDFSDKLib, nItem)
                nTextInfoLen = VeryPDF_PDFParserSDK_GetTextInfoLength(nPDFSDKLib, nItem)
                ReDim vecImgData(nImageDataLen)
                ReDim vecTxtData(nTextInfoLen)
                VeryPDF_PDFParserSDK_GetImageData(nPDFSDKLib, nItem, vecImgData(0), nImageDataLen)
                VeryPDF_PDFParserSDK_GetTextInfoData(nPDFSDKLib, nItem, vecTxtData(0), nTextInfoLen)
                strLogMsg = System.Text.Encoding.ASCII.GetString(vecTxtData)
                If nTextInfoLen = 0 Then
                    strLogMsg = "This page hasn't text contents."
                End If
                If strLogMsg.Length > 300 Then
                    strLogMsg = strLogMsg.Substring(0, 300)
                End If
                MsgBox(strLogMsg, 0, "Text contents of Page " & Str(page))
            Next nItem
            VeryPDF_PDFParserSDK_Free(nPDFSDKLib)
            nPDFSDKLib = Nothing
        Next page
    End Sub

    Private Sub GetPageCount_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GetPageCount.Click
        Dim strOptions As String
        Dim strInPDFFile As String
        Dim HandleId As Integer
        Dim strLogMsg As String

        strInPDFFile = Application.StartupPath() & "\example3_tst1.pdf"
        strOptions = "-$ XXXXXXXXXXXXXXXXX -f 1 -l 78"
        ' strOptions = strOptions & " -noimg"
        HandleId = VeryPDF_PDFParserSDK_GetHandle(strInPDFFile, strOptions)
        Dim cnt As Integer = VeryPDF_PDFParserSDK_GetAllPagesCount(HandleId)
        strLogMsg = "PageCount of """ + strInPDFFile + """ file is:" + vbCrLf
        strLogMsg = strLogMsg + "VeryPDF_PDFParserSDK_GetAllPagesCount() return:" + Str(cnt) + vbCrLf

        Dim nPageCount As Integer = VeryPDF_PDFParserSDK_GetPageCount(strInPDFFile)

        strLogMsg = strLogMsg + "VeryPDF_PDFParserSDK_GetPageCount() return:" + Str(nPageCount)
        MsgBox(strLogMsg)
    End Sub
End Class
